# Contributing to `awesome-shell`

> _NOTE:_ This repo has been mostly unpoliced in terms of what has been accepted and was has been turned away up until now, so with the addition of this document, changes to the existing contents of the lists will need to be made. The repo is being re-structured to clean things up a bit, but this is being done gradually, so let me know if you have questions or concerns.

If you have questions about how to actually submit a pull request via GitHub to contribute content to this list, the [main `awesome` repository](https://github.com/sindresorhus/awesome) has an excellent [guide](https://github.com/sindresorhus/awesome/blob/master/contributing.md#adding-something-to-an-awesome-list) that walks through the steps. This document, meanwhile, is intended more for prospective contributors to define the scope of this project and outline guidelines for accepting or rejecting things from the repository.

## Criteria for inclusion in `awesome-shell`

Inclusion of projects and entries in the list are based primarily upon  _scope_ of the project, book, link, etc. that is being considered, and, for code/tools/projects on GitHub, _notability_ of the project.

### Scope
`awesome-shell` is a list of helpful links, tools, projects, frameworks, and resources for shell development and usage.

#### Accepted

- *CLI apps* of any kind are acceptable. They do not have to be written in a shell script (e.g. Bash, Fish, Zsh) to be accepted.
- *Shell extensions/plugins* are acceptable. If the item in consideration doesn't depend on a particular package manager/shell, it can go in a suitable category; otherwise (i.e. if it is only applicable to a certain shell or depends on a certain package manager that depends on a certain shell, such as Oh-My-Zsh) it should go in the category for that shell.
- *Guides* or *tutorials* for shell scripting in general or particular shells are welcome.

#### Rejected

- *Terminal emulators*, such as Hyper, iTerm2, Upterm, etc. should be submitted to [`terminals-are-sexy`](https://github.com/k4m4/terminals-are-sexy) instead.

This list may be expanded and moved around as the situation changes or new cases arise.

### Notability
- It is *acceptable* to submit items/links/guides/projects that you authored or developed on your own. Self-promotion is okay!
- GitHub projects must have _at least_ 50 stars to be considered for inclusion. This applies to both projects authored by others but submitted by you as well as any projects that you developed or authored yourself.
<hr />

Any questions? Feel free to open an issue or email me. This document will be updated to reflect any sort of changes that may occur.
